// **********************************************************************
//
// Copyright (c) 2003-2013 ZeroC, Inc. All rights reserved.
//
// This copy of Ice is licensed to you under the terms described in the
// ICE_LICENSE file included in this distribution.
//
// **********************************************************************
//
// Ice version 3.5.1
//
// <auto-generated>
//
// Generated from file `Observer.ice'
//
// Warning: do not edit this file.
//
// </auto-generated>
//

package IceGrid;

/**
 * This interface allows applications to monitor IceGrid well-known objects.
 * 
 **/
public final class ObjectObserverPrxHelper extends Ice.ObjectPrxHelperBase implements ObjectObserverPrx
{
    private static final String __objectAdded_name = "objectAdded";

    /**
     * The <tt>objectAdded</tt> operation is called to notify an observer when an
     * object was added to the {@link Admin} interface.
     * 
     * @param info The details of the added object.
     * 
     **/
    public void objectAdded(ObjectInfo info)
    {
        objectAdded(info, null, false);
    }

    /**
     * The <tt>objectAdded</tt> operation is called to notify an observer when an
     * object was added to the {@link Admin} interface.
     * 
     * @param info The details of the added object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void objectAdded(ObjectInfo info, java.util.Map<String, String> __ctx)
    {
        objectAdded(info, __ctx, true);
    }

    private void objectAdded(ObjectInfo info, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "objectAdded", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _ObjectObserverDel __del = (_ObjectObserverDel)__delBase;
                    __del.objectAdded(info, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * The <tt>objectAdded</tt> operation is called to notify an observer when an
     * object was added to the {@link Admin} interface.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the added object.
     * 
     **/
    public Ice.AsyncResult begin_objectAdded(ObjectInfo info)
    {
        return begin_objectAdded(info, null, false, null);
    }

    /**
     * The <tt>objectAdded</tt> operation is called to notify an observer when an
     * object was added to the {@link Admin} interface.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the added object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectAdded(ObjectInfo info, java.util.Map<String, String> __ctx)
    {
        return begin_objectAdded(info, __ctx, true, null);
    }

    /**
     * The <tt>objectAdded</tt> operation is called to notify an observer when an
     * object was added to the {@link Admin} interface.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the added object.
     * 
     **/
    public Ice.AsyncResult begin_objectAdded(ObjectInfo info, Ice.Callback __cb)
    {
        return begin_objectAdded(info, null, false, __cb);
    }

    /**
     * The <tt>objectAdded</tt> operation is called to notify an observer when an
     * object was added to the {@link Admin} interface.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the added object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectAdded(ObjectInfo info, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_objectAdded(info, __ctx, true, __cb);
    }

    /**
     * The <tt>objectAdded</tt> operation is called to notify an observer when an
     * object was added to the {@link Admin} interface.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the added object.
     * 
     **/
    public Ice.AsyncResult begin_objectAdded(ObjectInfo info, Callback_ObjectObserver_objectAdded __cb)
    {
        return begin_objectAdded(info, null, false, __cb);
    }

    /**
     * The <tt>objectAdded</tt> operation is called to notify an observer when an
     * object was added to the {@link Admin} interface.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the added object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectAdded(ObjectInfo info, java.util.Map<String, String> __ctx, Callback_ObjectObserver_objectAdded __cb)
    {
        return begin_objectAdded(info, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_objectAdded(ObjectInfo info, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __objectAdded_name, __cb);
        try
        {
            __result.__prepare(__objectAdded_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            info.__write(__os);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_objectAdded(Ice.AsyncResult __result)
    {
        __end(__result, __objectAdded_name);
    }

    private static final String __objectInit_name = "objectInit";

    /**
     * <tt>objectInit</tt> is called after the registration of
     * an observer to indicate the state of the registry.
     * 
     * @param objects The objects registered with the {@link Admin}
     * interface (not through the deployment mechanism).
     * 
     **/
    public void objectInit(ObjectInfo[] objects)
    {
        objectInit(objects, null, false);
    }

    /**
     * <tt>objectInit</tt> is called after the registration of
     * an observer to indicate the state of the registry.
     * 
     * @param objects The objects registered with the {@link Admin}
     * interface (not through the deployment mechanism).
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void objectInit(ObjectInfo[] objects, java.util.Map<String, String> __ctx)
    {
        objectInit(objects, __ctx, true);
    }

    private void objectInit(ObjectInfo[] objects, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "objectInit", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _ObjectObserverDel __del = (_ObjectObserverDel)__delBase;
                    __del.objectInit(objects, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * <tt>objectInit</tt> is called after the registration of
     * an observer to indicate the state of the registry.
     * 
     * @param __cb The callback object for the operation.
     * @param objects The objects registered with the {@link Admin}
     * interface (not through the deployment mechanism).
     * 
     **/
    public Ice.AsyncResult begin_objectInit(ObjectInfo[] objects)
    {
        return begin_objectInit(objects, null, false, null);
    }

    /**
     * <tt>objectInit</tt> is called after the registration of
     * an observer to indicate the state of the registry.
     * 
     * @param __cb The callback object for the operation.
     * @param objects The objects registered with the {@link Admin}
     * interface (not through the deployment mechanism).
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectInit(ObjectInfo[] objects, java.util.Map<String, String> __ctx)
    {
        return begin_objectInit(objects, __ctx, true, null);
    }

    /**
     * <tt>objectInit</tt> is called after the registration of
     * an observer to indicate the state of the registry.
     * 
     * @param __cb The callback object for the operation.
     * @param objects The objects registered with the {@link Admin}
     * interface (not through the deployment mechanism).
     * 
     **/
    public Ice.AsyncResult begin_objectInit(ObjectInfo[] objects, Ice.Callback __cb)
    {
        return begin_objectInit(objects, null, false, __cb);
    }

    /**
     * <tt>objectInit</tt> is called after the registration of
     * an observer to indicate the state of the registry.
     * 
     * @param __cb The callback object for the operation.
     * @param objects The objects registered with the {@link Admin}
     * interface (not through the deployment mechanism).
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectInit(ObjectInfo[] objects, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_objectInit(objects, __ctx, true, __cb);
    }

    /**
     * <tt>objectInit</tt> is called after the registration of
     * an observer to indicate the state of the registry.
     * 
     * @param __cb The callback object for the operation.
     * @param objects The objects registered with the {@link Admin}
     * interface (not through the deployment mechanism).
     * 
     **/
    public Ice.AsyncResult begin_objectInit(ObjectInfo[] objects, Callback_ObjectObserver_objectInit __cb)
    {
        return begin_objectInit(objects, null, false, __cb);
    }

    /**
     * <tt>objectInit</tt> is called after the registration of
     * an observer to indicate the state of the registry.
     * 
     * @param __cb The callback object for the operation.
     * @param objects The objects registered with the {@link Admin}
     * interface (not through the deployment mechanism).
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectInit(ObjectInfo[] objects, java.util.Map<String, String> __ctx, Callback_ObjectObserver_objectInit __cb)
    {
        return begin_objectInit(objects, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_objectInit(ObjectInfo[] objects, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __objectInit_name, __cb);
        try
        {
            __result.__prepare(__objectInit_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            ObjectInfoSeqHelper.write(__os, objects);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_objectInit(Ice.AsyncResult __result)
    {
        __end(__result, __objectInit_name);
    }

    private static final String __objectRemoved_name = "objectRemoved";

    /**
     * <tt>objectRemoved</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was removed.
     * 
     * @param id The identity of the removed object.
     * 
     **/
    public void objectRemoved(Ice.Identity id)
    {
        objectRemoved(id, null, false);
    }

    /**
     * <tt>objectRemoved</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was removed.
     * 
     * @param id The identity of the removed object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void objectRemoved(Ice.Identity id, java.util.Map<String, String> __ctx)
    {
        objectRemoved(id, __ctx, true);
    }

    private void objectRemoved(Ice.Identity id, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "objectRemoved", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _ObjectObserverDel __del = (_ObjectObserverDel)__delBase;
                    __del.objectRemoved(id, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * <tt>objectRemoved</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was removed.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity of the removed object.
     * 
     **/
    public Ice.AsyncResult begin_objectRemoved(Ice.Identity id)
    {
        return begin_objectRemoved(id, null, false, null);
    }

    /**
     * <tt>objectRemoved</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was removed.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity of the removed object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectRemoved(Ice.Identity id, java.util.Map<String, String> __ctx)
    {
        return begin_objectRemoved(id, __ctx, true, null);
    }

    /**
     * <tt>objectRemoved</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was removed.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity of the removed object.
     * 
     **/
    public Ice.AsyncResult begin_objectRemoved(Ice.Identity id, Ice.Callback __cb)
    {
        return begin_objectRemoved(id, null, false, __cb);
    }

    /**
     * <tt>objectRemoved</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was removed.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity of the removed object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectRemoved(Ice.Identity id, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_objectRemoved(id, __ctx, true, __cb);
    }

    /**
     * <tt>objectRemoved</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was removed.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity of the removed object.
     * 
     **/
    public Ice.AsyncResult begin_objectRemoved(Ice.Identity id, Callback_ObjectObserver_objectRemoved __cb)
    {
        return begin_objectRemoved(id, null, false, __cb);
    }

    /**
     * <tt>objectRemoved</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was removed.
     * 
     * @param __cb The callback object for the operation.
     * @param id The identity of the removed object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectRemoved(Ice.Identity id, java.util.Map<String, String> __ctx, Callback_ObjectObserver_objectRemoved __cb)
    {
        return begin_objectRemoved(id, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_objectRemoved(Ice.Identity id, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __objectRemoved_name, __cb);
        try
        {
            __result.__prepare(__objectRemoved_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            id.__write(__os);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_objectRemoved(Ice.AsyncResult __result)
    {
        __end(__result, __objectRemoved_name);
    }

    private static final String __objectUpdated_name = "objectUpdated";

    /**
     * <tt>objectUpdated</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was updated.
     * 
     * @param info The details of the updated object.
     * 
     **/
    public void objectUpdated(ObjectInfo info)
    {
        objectUpdated(info, null, false);
    }

    /**
     * <tt>objectUpdated</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was updated.
     * 
     * @param info The details of the updated object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public void objectUpdated(ObjectInfo info, java.util.Map<String, String> __ctx)
    {
        objectUpdated(info, __ctx, true);
    }

    private void objectUpdated(ObjectInfo info, java.util.Map<String, String> __ctx, boolean __explicitCtx)
    {
        if(__explicitCtx && __ctx == null)
        {
            __ctx = _emptyContext;
        }
        final Ice.Instrumentation.InvocationObserver __observer = IceInternal.ObserverHelper.get(this, "objectUpdated", __ctx);
        int __cnt = 0;
        try
        {
            while(true)
            {
                Ice._ObjectDel __delBase = null;
                try
                {
                    __delBase = __getDelegate(false);
                    _ObjectObserverDel __del = (_ObjectObserverDel)__delBase;
                    __del.objectUpdated(info, __ctx, __observer);
                    return;
                }
                catch(IceInternal.LocalExceptionWrapper __ex)
                {
                    __handleExceptionWrapper(__delBase, __ex, __observer);
                }
                catch(Ice.LocalException __ex)
                {
                    __cnt = __handleException(__delBase, __ex, null, __cnt, __observer);
                }
            }
        }
        finally
        {
            if(__observer != null)
            {
                __observer.detach();
            }
        }
    }

    /**
     * <tt>objectUpdated</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was updated.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the updated object.
     * 
     **/
    public Ice.AsyncResult begin_objectUpdated(ObjectInfo info)
    {
        return begin_objectUpdated(info, null, false, null);
    }

    /**
     * <tt>objectUpdated</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was updated.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the updated object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectUpdated(ObjectInfo info, java.util.Map<String, String> __ctx)
    {
        return begin_objectUpdated(info, __ctx, true, null);
    }

    /**
     * <tt>objectUpdated</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was updated.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the updated object.
     * 
     **/
    public Ice.AsyncResult begin_objectUpdated(ObjectInfo info, Ice.Callback __cb)
    {
        return begin_objectUpdated(info, null, false, __cb);
    }

    /**
     * <tt>objectUpdated</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was updated.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the updated object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectUpdated(ObjectInfo info, java.util.Map<String, String> __ctx, Ice.Callback __cb)
    {
        return begin_objectUpdated(info, __ctx, true, __cb);
    }

    /**
     * <tt>objectUpdated</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was updated.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the updated object.
     * 
     **/
    public Ice.AsyncResult begin_objectUpdated(ObjectInfo info, Callback_ObjectObserver_objectUpdated __cb)
    {
        return begin_objectUpdated(info, null, false, __cb);
    }

    /**
     * <tt>objectUpdated</tt> is called to notify an observer when
     * an object registered with the {@link Admin} interface was updated.
     * 
     * @param __cb The callback object for the operation.
     * @param info The details of the updated object.
     * 
     * @param __ctx The Context map to send with the invocation.
     **/
    public Ice.AsyncResult begin_objectUpdated(ObjectInfo info, java.util.Map<String, String> __ctx, Callback_ObjectObserver_objectUpdated __cb)
    {
        return begin_objectUpdated(info, __ctx, true, __cb);
    }

    private Ice.AsyncResult begin_objectUpdated(ObjectInfo info, java.util.Map<String, String> __ctx, boolean __explicitCtx, IceInternal.CallbackBase __cb)
    {
        IceInternal.OutgoingAsync __result = new IceInternal.OutgoingAsync(this, __objectUpdated_name, __cb);
        try
        {
            __result.__prepare(__objectUpdated_name, Ice.OperationMode.Normal, __ctx, __explicitCtx);
            IceInternal.BasicStream __os = __result.__startWriteParams(Ice.FormatType.DefaultFormat);
            info.__write(__os);
            __result.__endWriteParams();
            __result.__send(true);
        }
        catch(Ice.LocalException __ex)
        {
            __result.__exceptionAsync(__ex);
        }
        return __result;
    }

    /**
     * ice_response indicates that
     * the operation completed successfully.
     **/
    public void end_objectUpdated(Ice.AsyncResult __result)
    {
        __end(__result, __objectUpdated_name);
    }

    public static ObjectObserverPrx checkedCast(Ice.ObjectPrx __obj)
    {
        ObjectObserverPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ObjectObserverPrx)
            {
                __d = (ObjectObserverPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId()))
                {
                    ObjectObserverPrxHelper __h = new ObjectObserverPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ObjectObserverPrx checkedCast(Ice.ObjectPrx __obj, java.util.Map<String, String> __ctx)
    {
        ObjectObserverPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ObjectObserverPrx)
            {
                __d = (ObjectObserverPrx)__obj;
            }
            else
            {
                if(__obj.ice_isA(ice_staticId(), __ctx))
                {
                    ObjectObserverPrxHelper __h = new ObjectObserverPrxHelper();
                    __h.__copyFrom(__obj);
                    __d = __h;
                }
            }
        }
        return __d;
    }

    public static ObjectObserverPrx checkedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ObjectObserverPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId()))
                {
                    ObjectObserverPrxHelper __h = new ObjectObserverPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ObjectObserverPrx checkedCast(Ice.ObjectPrx __obj, String __facet, java.util.Map<String, String> __ctx)
    {
        ObjectObserverPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            try
            {
                if(__bb.ice_isA(ice_staticId(), __ctx))
                {
                    ObjectObserverPrxHelper __h = new ObjectObserverPrxHelper();
                    __h.__copyFrom(__bb);
                    __d = __h;
                }
            }
            catch(Ice.FacetNotExistException ex)
            {
            }
        }
        return __d;
    }

    public static ObjectObserverPrx uncheckedCast(Ice.ObjectPrx __obj)
    {
        ObjectObserverPrx __d = null;
        if(__obj != null)
        {
            if(__obj instanceof ObjectObserverPrx)
            {
                __d = (ObjectObserverPrx)__obj;
            }
            else
            {
                ObjectObserverPrxHelper __h = new ObjectObserverPrxHelper();
                __h.__copyFrom(__obj);
                __d = __h;
            }
        }
        return __d;
    }

    public static ObjectObserverPrx uncheckedCast(Ice.ObjectPrx __obj, String __facet)
    {
        ObjectObserverPrx __d = null;
        if(__obj != null)
        {
            Ice.ObjectPrx __bb = __obj.ice_facet(__facet);
            ObjectObserverPrxHelper __h = new ObjectObserverPrxHelper();
            __h.__copyFrom(__bb);
            __d = __h;
        }
        return __d;
    }

    public static final String[] __ids =
    {
        "::Ice::Object",
        "::IceGrid::ObjectObserver"
    };

    public static String ice_staticId()
    {
        return __ids[1];
    }

    protected Ice._ObjectDelM __createDelegateM()
    {
        return new _ObjectObserverDelM();
    }

    protected Ice._ObjectDelD __createDelegateD()
    {
        return new _ObjectObserverDelD();
    }

    public static void __write(IceInternal.BasicStream __os, ObjectObserverPrx v)
    {
        __os.writeProxy(v);
    }

    public static ObjectObserverPrx __read(IceInternal.BasicStream __is)
    {
        Ice.ObjectPrx proxy = __is.readProxy();
        if(proxy != null)
        {
            ObjectObserverPrxHelper result = new ObjectObserverPrxHelper();
            result.__copyFrom(proxy);
            return result;
        }
        return null;
    }

    public static final long serialVersionUID = 0L;
}
